<%@ page contentType="text/html; encoding=windows-1250;charset=windows-1250" %>
<%@ page import="cviceni3.*" %>
<%--
Atribut strnky taglib slou k definici sady knihoven, kter chceme pout v rmci strnky.
V tomto souboru mte uvedeny 3. rzn zpsoby jeho pouit
1. u sady fmt pomoc fyzick cesty v rmci Va aplikace
2. u sady c tady v komenti JSP jako fyzick cesta na internetu
--%>
<%@ taglib uri="/WEB-INF/fmt.tld" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>


<%--
Tato znaka je definovna pmo specifikac JSP. Umouje asociovat do strnky komponentu, ke
kter je mon nsledn pistupovat v rmci jsp strnky.
id - jmno komponenty pod kterm j je mon vyuvat
class - tda implementujc komponentu
scope - prostor viditelnosti

Pokud tato znaka obsahuje tlo, pak je toto tlo provedeno jen v ppad vytvoen komponenty v danm kontextu.
To nm zajiuje v tomto ppad inicializaci kolekce jen jednou.
--%>
<jsp:useBean id="uzivatele" class="cviceni3.SeznamUzivatelu" scope="session">
<%
   uzivatele.uloz(new Uzivatel("wal314", "Johnny",  "Walker"));
   uzivatele.uloz(new Uzivatel("bon007", "James",   "Bond"));
   uzivatele.uloz(new Uzivatel("gat032", "William", "Gates"));
   uzivatele.uloz(new Uzivatel("gel20", "Yveta", "Geletiov"));
   uzivatele.uloz(new Uzivatel("nav083", "Lumr", "Nvrat"));
   uzivatele.uloz(new Uzivatel("ben64", "Miroslav", "Bene"));
%>
</jsp:useBean>

<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=windows-1250" />
    <meta http-equiv="Content-Language" content="cs" />
    <title>Cvien 3</title>
  </head>
  <body>
  <h2>JSTL 1</h2>
  <c:out value="Toto je pokusny text" />
  <table border="1">
  <%--
    Znaka forEach je zkladn znakou pro prochzen kolekce prvk. Pomoc tto znaky
    je mon ale rovn prochzet skrz rozsah index jako v klasickm cyklu for.

    var - jmno promnn ve kterm je uloena aktuln hodnota cyklu.
    varStatus - promnn, se stavovmi informacemi cyklu, jako je informace o potu prvk,
                zda se jedn o prvn prvek nebo posledn apod.
    items - kolekce, kterou chcem prochzet.

    begin  - poten index
    end    - koncov index
    step   - krok
    Podobn je znaka forTokens.
  --%>
  <c:forEach var="uziv" varStatus="st" items="${uzivatele.seznam}" >
    <%--
    Znaka pro podmnn vykonvn kdu.

    test - podmnka, kter se m otestovat a na jejm zklad se provede tlo znaky.
           Lze testovat nap na przdnou promnnou i naopak (empty, not empty).
    --%>
    <c:if test="${uziv.login == 'nav083'}">
      <%--
      Znaka umouje nastavit hodnotu njak promnn

      value - hodnota
      var - promnn, kterou chceme nastavit
      target - objekt, v rmci kterho chceme nastavit danou vlastnost.
      --%>
      <c:set target="${uziv}" property="role" value="doktorand" />
    </c:if>

    <%--
    Znaka nabzejc funkcionalitu podobnou pkazu switch.
    V rmci tla naleznete nkolik znakek <c:when> a voliteln jedna
    znaka <c:otherwise>, kter maj stejn vznam jako znaka <c:if>
    --%>
    <c:choose>
        <c:when test="${uziv.login == 'ben64'}">
          <c:set target="${uziv}" property="role" value="vedouc" />
        </c:when>
        <c:when test="${uziv.login == 'gel20'}">
          <c:set target="${uziv}" property="role" value="tajemnk" />
        </c:when>
        <c:when test="${uziv.login == 'nav083'}">
          <c:set target="${uziv}" property="role" value="${uziv.role}, cvic" />
        </c:when>
        <c:otherwise>
         <c:set target="${uziv}" property="role" value="student" />
        </c:otherwise>
    </c:choose>
  <tr>
    <%--
    Znaka pro vpis do strnky

    value - hodnota, kterou chceme vypsat
    --%>
    <td><c:out value="${st.count}"/></td>
    <td><c:out value="${uziv.login}"/></td>
    <td>
      <c:out value="${uziv.jmeno}"/>
      <c:out value="${uziv.prijmeni}"/>
    </td>
    <td>
      <c:out value="${uziv.role}" />
    </td>
  </tr>
  </c:forEach>
  </table>

  <%--
  Znaka pro vygenerovn URL adresy. Oproti pmmu zpisu m vhodu v tom,
  e pokud prohle m vypnut cookies, tak se do URL vlo ID session.

  V tl se mohou objevit parametry pro metodu GET.
  --%>
  <c:url var="url" value="priklad2.jsp">
    <c:param name="arg1" value="4"/>
    <c:param name="arg2" value="hodnota druhho argumentu"/>
  </c:url>
  Pokraujte na strnku <a href='<c:out value="${url}"/>'>priklad2.jsp</a>
  </body>
</html>
<%--
EL Expression Language
Jazyk pro psan vraz v rmci JSTL znaek.
Vyraz se zapisuje do mezi symboly ${}
pokud pouijeme njak slovo v rmci tohoto vrazu, je chpno jako promnn. Tyto promnn se hledaj v
jednotlivch kontextech (scope) postupn od page,request,session a k application. Pokud dnou takovou
promnnou nenalezne, tak teprve vyhls error.
V rmci tohoto souboru se tak jedn o promnnou uzivatele.

${uzivatele.seznam} je tak ekvivalentn zpisu v Jave uzivatele.getSeznam()
  - tento zpis vychz z specifikace JAVA Beans a vyuv pln reflexe.
--%>
